# Automatically generated, do not edit!

"""
What:    Python simulation
Author:  ingolf
Contact: arne.t.elve(at)ntnu.no
Date:    2019-06-14 13:29:14
Model:   cc_HEX_big
Case:    andreas
"""

# Import packages:
import numpy as np                                   # Numerical python library
from scipy.integrate import ode                           # Integrator in scipy
import matplotlib.pyplot as plt                             # Data illustration
from funcUtils import IndexSet, khatriRao, blockReduce, blockProduct   # Custom

from constants import *                                  # Import all constants
from networks import *                           # Import all network variables
from selections import *
# from selections_ import *                           # Import equation selections
# from initial_states_ import *
# =================================== BODY ================================== #

# INDEX SETS:
N = IndexSet('node', mapping = [1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49], blocking = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1])
A = IndexSet('arc', mapping = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67], blocking = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1])
S = IndexSet('species', mapping = [0, 1, 2], blocking = [1, 1, 1])
N_x_S = IndexSet('node & species', mapping = [1, 2, 3, 4, 43, 24, 13, 30, 21, 36, 27, 42, 32, 48, 40, 9, 46, 16, 7, 34, 49, 35, 39, 19, 10, 45, 26, 20, 12, 15, 11, 22, 38, 18, 6, 23, 47, 37, 29, 17, 8, 44, 33, 25, 14, 28, 41, 31], blocking = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1])
A_x_S = IndexSet('arc & species', mapping = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67], blocking = [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1])
R = IndexSet('species_conversion', mapping = [0], blocking = [1])
N_x_R = IndexSet('node & species_conversion', mapping = [1, 2, 3, 4, 43, 24, 13, 30, 21, 36, 27, 42, 32, 48, 40, 9, 46, 16, 7, 34, 49, 35, 39, 19, 10, 45, 26, 20, 12, 15, 11, 22, 38, 18, 6, 23, 47, 37, 29, 17, 8, 44, 33, 25, 14, 28, 41, 31], blocking = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0])

# Constant equations:
T_ref = np.multiply(en, T_298)
h_ref = np.transpose(np.dot(np.transpose(h_0), P_node_species))
cp = np.transpose(np.dot(np.transpose(cpn), P_node_species))
Pnsas = np.dot(np.transpose(P_node_species), P_arc_species)
Fn = khatriRao(F_mass_volumetric, [N, A], Pnsas, [N_x_S, A_x_S])


# INTEGRATING FUNCTION:
def derivative(t, n, H):
  """
  t: time
  state: n, H
  Integrating function:
  dxdt = derivative(t, state)

  Note: sequence of variables depends on integrator. Using scipy's ode requires
  time before state, while odeint needs state before time.  Also the integrator
  want  flat vectors,  no column vectors.  I, therefore, transpose  the vectors
  manually. Normal transpose is not sufficient.
  """
  # EQUATIONS:
  H_ref = blockReduce(h_ref, S, N_x_S, n)
  Cp = blockReduce(cp, S, N_x_S, n)
  T = np.add((np.multiply((np.reciprocal(Cp)), (np.subtract(H, H_ref)))), T_ref)
  qhat = np.multiply((np.multiply((-(U)), A_heat)), (np.dot(np.transpose(F_energy_heat), T)))
  ntot = blockReduce(ens, S, N_x_S, n)
  p = np.multiply((np.multiply((np.multiply((np.reciprocal(Vg)), ntot)), T)), Rg)
  dir = np.sign(np.dot(np.transpose(F_mass_volumetric), p))
  s_flow = np.multiply(half, (np.add((np.abs(F_mass_volumetric )), (np.multiply(F_mass_volumetric, np.transpose(dir))))))
  Vhat = np.multiply((np.multiply((-(kappa)), A_cross)), (np.dot(np.transpose(F_mass_volumetric), p)))
  Hhat = np.multiply(Vhat, (np.dot(np.transpose(s_flow), (np.multiply((np.reciprocal(Vg)), H)))))
  Hdot = np.add((np.dot(F_mass_volumetric, Hhat)), (np.dot(F_energy_heat, qhat)))
  c = khatriRao(np.reciprocal(Vg), [N], n, [N_x_S])
  chat = np.dot(np.transpose((khatriRao(s_flow, [N, A], Pnsas, [N_x_S, A_x_S]))), c)
  nhat = khatriRao(Vhat, [A], chat, [A_x_S])
  ndot = np.dot(Fn, nhat)
  # FIX THIS: IS IT NOW OK?
  return np.multiply(Selection_ndot, ndot), np.multiply(Selection_Hdot, Hdot)

def integrand(t, state):
  # HACK: Integrator give flat state vectors while our model is column vector
  n = state[0:48, np.newaxis]
  H = state[48:96, np.newaxis]
  ndot, Hdot = derivative(t, n,  H)
  return np.concatenate([np.transpose(ndot)[0], np.transpose(Hdot)[0]])

# INTEGRATOR
data = {}
data['n'] = []
data['H'] = []
data['t'] = []
dt = 0.1
t_start = 0.0
t_end  = 15.                                               # Handcoded!!!
integrator = ode(integrand).set_integrator('vode')
state = np.concatenate([np.transpose(n)[0], np.transpose(H)[0]])
integrator.set_initial_value(state, t_start)
data['t'].append(integrator.t)
data['n'].append(state[0:48, np.newaxis])
data['H'].append(state[48:96, np.newaxis])

while integrator.successful() and integrator.t < t_end :
  print(integrator.t)
  state = integrator.integrate(integrator.t + dt)
  data['t'].append(integrator.t)
  data['n'].append(state[0:48, np.newaxis])
  data['H'].append(state[48:96, np.newaxis])

'''
data['n'] = np.transpose(data['n'])[0]
for i, (dat) in enumerate(data['n']):
  plt.plot(data['t'], dat)
plt.xlim(0,15)
plt.show()
'''

data['H'] = np.transpose(data['H'])[0]
for i, (dat) in enumerate(data['H']):
  plt.plot(data['t'], dat)
plt.xlim(0,15)
plt.show()
